// CS559-2007 - Project 1 - Picture Processor
//
// Example Solution, by Mike Gleicher
// begin 9/10/2007

// file: Darken.cpp
// implements the darken commands

#include "PictureProcessor.H"
#include "TargaImage.H"

// multiply a pixel value (unsigned char) by a float)
// syntactically ugly, so make it a function
static inline void darken(unsigned char& v, const float f)
{
	v = static_cast<unsigned char>( f * static_cast<float>(v) );
}

// syntax darken V a
class DarkenCmd : public Command
{
public:
	DarkenCmd() : Command("darken",3) {};
	virtual int doit(const std::vector<const char*>& cmd,
					 Context& context) {
						 TargaImage* img = context.getImage(cmd[1]);
						 if (!img) {
							 printf("Error (line %d): No image to Darken\n",context.lineNo);
							 return 1;
						 }
						 // need a cast since atof returns a double
						 float f = static_cast<float>(atof(cmd[2]));
						 if (f<=0 || f>=1) {
							 printf("Error (line %d): Darken amount out of range (0 < a < 1)\n",context.lineNo);
							 return 1;
						 };
						 // now loop over the pixels and darken each one
						 unsigned char* p = img->pixels();
						 for(unsigned int c = img->height() * img->width(); c; c--) {
							 darken(*p++,f);
							 darken(*p++,f);
							 darken(*p++,f);
							 p++;
						 }
						return 0;
	};
};
// be sure to create an instance of one of these
DarkenCmd darkenCmd;

